/*----- PROTECTED REGION ID(Omega_CN7.h) ENABLED START -----*/
//=============================================================================
//
// file :        Omega_CN7.h
//
// description : Include for the Omega_CN7 class.
//
// project :     OMEGA CN7 series temperature/process controller.
//
// $Author: borghes $
//
// $Revision: 1.1.1.1 $
// $Date: 2013-12-24 14:51:55 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/omegacn7x/src/Omega_CN7.h,v $
// $Log: Omega_CN7.h,v $
// Revision 1.1.1.1  2013-12-24 14:51:55  borghes
// OMEGA CN7x Device Server
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef OMEGA_CN7_H
#define OMEGA_CN7_H


#include <tango.h>

/*----- PROTECTED REGION END -----*/
#define REGISTER_OFFSET	4096

#define	PROCESS_VALUE_ADDR	0	
#define	SET_POINT_ADDR	1
#define UPPER_LIMIT_TEMP_ADDR	2	
#define LOWER_LIMIT_TEMP_ADDR	3	
#define SENSOR_TYPE_ADDR	4	
#define CONTROL_METHOD_ADDR	5
#define HEATING_COOLING_CTRL_ADDR	6
#define	LED_STATUS_ADDR	42


#define COIL_OFFSET	2064
#define	ENABLE_WRITING_ADDR	0	
#define	TEMP_UNIT_ADDR	1


/**
 *	Omega_CN7 class Description:
 *	OMEGA CN7200, CN7500, CN7600, CN7800 Series
 */

namespace Omega_CN7_ns
{
	/*----- PROTECTED REGION ID(Omega_CN7::Additional Class Declarations) ENABLED START -----*/

		//		Additional Class Declarations

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Additional Class Declarations


class Omega_CN7 : public Tango::Device_4Impl
{


	/*----- PROTECTED REGION ID(Omega_CN7::Data Members) ENABLED START -----*/

	//		Add your own data members

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Data Members


//	Device property data members
public:		//	Modbus_devicename:	TANGO Modbus communication device name
	string	modbus_devicename;
	

//	Attribute data members
public:
	Tango::DevBoolean	*attr_ParametersReadonly_read;
	Tango::DevDouble	*attr_SetPoint_read;
	Tango::DevDouble	*attr_Temp_Upper_Limit_read;
	Tango::DevDouble	*attr_Temp_Lower_Limit_read;
	Tango::DevShort	*attr_SensorType_read;
	Tango::DevShort	*attr_Control_method_read;
	Tango::DevShort	*attr_Heating_Cooling_Control_read;
	Tango::DevDouble	*attr_TemperatureValue_read;
	Tango::DevShort	*attr_Temperature_Unit_read;
	Tango::DevShort	*attr_Led_Status_read;



//	Constructors and destructors
public:
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Omega_CN7(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Omega_CN7(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Omega_CN7(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The object destructor.
	 */	
	~Omega_CN7() {delete_device();};



//	Miscellaneous methods
public:
	/**
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/**
	 *	Initialize the device
	 */
	virtual void init_device();
	/**
	 *	Read the device properties from database
	 */
	 void get_device_property();
	/**
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	/**
	 *	Method      : Omega_CN7::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	virtual void read_attr_hardware(vector<long> &attr_list);


	/**
	 *	ParametersReadonly attribute related methods.
	 *	Description: Enable or Disable parameters writing via modbus
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar 
	 */
	virtual void read_ParametersReadonly(Tango::Attribute &attr);
	virtual void write_ParametersReadonly(Tango::WAttribute &attr);
	virtual bool is_ParametersReadonly_allowed(Tango::AttReqType type);



	/**
	 *	SetPoint attribute related methods.
	 *	Description: Temperature set point, unit is C or F.
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_SetPoint(Tango::Attribute &attr);
	virtual void write_SetPoint(Tango::WAttribute &attr);
	virtual bool is_SetPoint_allowed(Tango::AttReqType type);



	/**
	 *	Temp_Upper_Limit attribute related methods.
	 *	Description: The data content should not be higher than the temperature range
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_Temp_Upper_Limit(Tango::Attribute &attr);
	virtual void write_Temp_Upper_Limit(Tango::WAttribute &attr);
	virtual bool is_Temp_Upper_Limit_allowed(Tango::AttReqType type);



	/**
	 *	Temp_Lower_Limit attribute related methods.
	 *	Description: The data content should not be lower than the temperature range
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_Temp_Lower_Limit(Tango::Attribute &attr);
	virtual void write_Temp_Lower_Limit(Tango::WAttribute &attr);
	virtual bool is_Temp_Lower_Limit_allowed(Tango::AttReqType type);



	/**
	 *	SensorType attribute related methods.
	 *	Description: Please refer to the manual: contents of the ?Temperature Sensor Type and Temperature Range? for detail
	 *
	 *	Data type:	Tango::DevShort
	 *	Attr type:	Scalar 
	 */
	virtual void read_SensorType(Tango::Attribute &attr);
	virtual void write_SensorType(Tango::WAttribute &attr);
	virtual bool is_SensorType_allowed(Tango::AttReqType type);



	/**
	 *	Control_method attribute related methods.
	 *	Description: 0: PID, 1: ON/OFF, 2: manual tuning, 3: PID grogram control
	 *
	 *	Data type:	Tango::DevShort
	 *	Attr type:	Scalar 
	 */
	virtual void read_Control_method(Tango::Attribute &attr);
	virtual void write_Control_method(Tango::WAttribute &attr);
	virtual bool is_Control_method_allowed(Tango::AttReqType type);



	/**
	 *	Heating_Cooling_Control attribute related methods.
	 *	Description: 0: Heating, 1: Cooling, 2: Heating/Cooling, 3: Cooling/Heating
	 *
	 *	Data type:	Tango::DevShort
	 *	Attr type:	Scalar 
	 */
	virtual void read_Heating_Cooling_Control(Tango::Attribute &attr);
	virtual void write_Heating_Cooling_Control(Tango::WAttribute &attr);
	virtual bool is_Heating_Cooling_Control_allowed(Tango::AttReqType type);



	/**
	 *	TemperatureValue attribute related methods.
	 *	Description: Measuring unit is C or F, updated one time in 0.4 second
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_TemperatureValue(Tango::Attribute &attr);
	virtual bool is_TemperatureValue_allowed(Tango::AttReqType type);



	/**
	 *	Temperature_Unit attribute related methods.
	 *	Description: C/linear input (default): 1 , F : 0
	 *
	 *	Data type:	Tango::DevShort
	 *	Attr type:	Scalar 
	 */
	virtual void read_Temperature_Unit(Tango::Attribute &attr);
	virtual void write_Temperature_Unit(Tango::WAttribute &attr);
	virtual bool is_Temperature_Unit_allowed(Tango::AttReqType type);



	/**
	 *	Led_Status attribute related methods.
	 *	Description: b0: Alm3, b1: Alm2, b2: F, b3:?, b4: Alm1, b5: OUT2, b6: OUT1, b7: AT
	 *
	 *	Data type:	Tango::DevShort
	 *	Attr type:	Scalar 
	 */
	virtual void read_Led_Status(Tango::Attribute &attr);
	virtual bool is_Led_Status_allowed(Tango::AttReqType type);



	/**
	 *	Method      : Omega_CN7::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
		void add_dynamic_attributes();

//	Command related methods
public: 




	/*----- PROTECTED REGION ID(Omega_CN7::Additional Method prototypes) ENABLED START -----*/

	//	Additional Method prototypes
	Tango::DeviceProxy *modbus_device;

	bool get_modbus_connection();
	void close_connection(Tango::DeviceProxy *);
	bool check_connection(Tango::DeviceProxy *);
	
	int modbus_read_register(short address);
	void modbus_write_register(short address, int value);
	int modbus_read_coil(short address);
	void modbus_write_coil(short address, int value);
	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Additional Method prototypes

};

	/*----- PROTECTED REGION ID(Omega_CN7::Additional Classes Definitions) ENABLED START -----*/

	//	Additional Classes definitions

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Additional Classes Definitions

} //	namespace

#endif	//	OMEGA_CN7_H
