/*----- PROTECTED REGION ID(Omega_CN7Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        Omega_CN7Class.h
//
// description : Include for the Omega_CN7Class root class.
//               This class is the singleton class for.
//               the Omega_CN7 device class..
//               It contains all properties and methods which the .
//               Omega_CN7 requires only once e.g. the commands.
//
// project :     OMEGA CN7 series temperature/process controller.
//
// $Author: borghes $
//
// $Revision: 1.1.1.1 $
// $Date: 2013-12-24 14:51:55 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/omegacn7x/src/Omega_CN7Class.h,v $
// $Log: Omega_CN7Class.h,v $
// Revision 1.1.1.1  2013-12-24 14:51:55  borghes
// OMEGA CN7x Device Server
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef OMEGA_CN7CLASS_H
#define OMEGA_CN7CLASS_H

#include <tango.h>
#include <Omega_CN7.h>

/*----- PROTECTED REGION END -----*/

namespace Omega_CN7_ns
{
	/*----- PROTECTED REGION ID(Omega_CN7::classes for dynamic creation) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::classes for dynamic creation



//=========================================
//	Define classes for attributes
//=========================================
//	Attribute ParametersReadonly class definition
class ParametersReadonlyAttrib: public Tango::Attr
{
public:
	ParametersReadonlyAttrib():Attr("ParametersReadonly",
	                   Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~ParametersReadonlyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Omega_CN7 *>(dev))->read_ParametersReadonly(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Omega_CN7 *>(dev))->write_ParametersReadonly(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Omega_CN7 *>(dev))->is_ParametersReadonly_allowed(ty);}
};

//	Attribute SetPoint class definition
class SetPointAttrib: public Tango::Attr
{
public:
	SetPointAttrib():Attr("SetPoint",
	                   Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~SetPointAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Omega_CN7 *>(dev))->read_SetPoint(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Omega_CN7 *>(dev))->write_SetPoint(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Omega_CN7 *>(dev))->is_SetPoint_allowed(ty);}
};

//	Attribute Temp_Upper_Limit class definition
class Temp_Upper_LimitAttrib: public Tango::Attr
{
public:
	Temp_Upper_LimitAttrib():Attr("Temp_Upper_Limit",
	                   Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~Temp_Upper_LimitAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Omega_CN7 *>(dev))->read_Temp_Upper_Limit(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Omega_CN7 *>(dev))->write_Temp_Upper_Limit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Omega_CN7 *>(dev))->is_Temp_Upper_Limit_allowed(ty);}
};

//	Attribute Temp_Lower_Limit class definition
class Temp_Lower_LimitAttrib: public Tango::Attr
{
public:
	Temp_Lower_LimitAttrib():Attr("Temp_Lower_Limit",
	                   Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~Temp_Lower_LimitAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Omega_CN7 *>(dev))->read_Temp_Lower_Limit(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Omega_CN7 *>(dev))->write_Temp_Lower_Limit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Omega_CN7 *>(dev))->is_Temp_Lower_Limit_allowed(ty);}
};

//	Attribute SensorType class definition
class SensorTypeAttrib: public Tango::Attr
{
public:
	SensorTypeAttrib():Attr("SensorType",
	                   Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~SensorTypeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Omega_CN7 *>(dev))->read_SensorType(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Omega_CN7 *>(dev))->write_SensorType(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Omega_CN7 *>(dev))->is_SensorType_allowed(ty);}
};

//	Attribute Control_method class definition
class Control_methodAttrib: public Tango::Attr
{
public:
	Control_methodAttrib():Attr("Control_method",
	                   Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~Control_methodAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Omega_CN7 *>(dev))->read_Control_method(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Omega_CN7 *>(dev))->write_Control_method(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Omega_CN7 *>(dev))->is_Control_method_allowed(ty);}
};

//	Attribute Heating_Cooling_Control class definition
class Heating_Cooling_ControlAttrib: public Tango::Attr
{
public:
	Heating_Cooling_ControlAttrib():Attr("Heating_Cooling_Control",
	                   Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~Heating_Cooling_ControlAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Omega_CN7 *>(dev))->read_Heating_Cooling_Control(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Omega_CN7 *>(dev))->write_Heating_Cooling_Control(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Omega_CN7 *>(dev))->is_Heating_Cooling_Control_allowed(ty);}
};

//	Attribute TemperatureValue class definition
class TemperatureValueAttrib: public Tango::Attr
{
public:
	TemperatureValueAttrib():Attr("TemperatureValue",
	                   Tango::DEV_DOUBLE, Tango::READ) {};
	~TemperatureValueAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Omega_CN7 *>(dev))->read_TemperatureValue(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Omega_CN7 *>(dev))->is_TemperatureValue_allowed(ty);}
};

//	Attribute Temperature_Unit class definition
class Temperature_UnitAttrib: public Tango::Attr
{
public:
	Temperature_UnitAttrib():Attr("Temperature_Unit",
	                   Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~Temperature_UnitAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Omega_CN7 *>(dev))->read_Temperature_Unit(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Omega_CN7 *>(dev))->write_Temperature_Unit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Omega_CN7 *>(dev))->is_Temperature_Unit_allowed(ty);}
};

//	Attribute Led_Status class definition
class Led_StatusAttrib: public Tango::Attr
{
public:
	Led_StatusAttrib():Attr("Led_Status",
	                   Tango::DEV_SHORT, Tango::READ) {};
	~Led_StatusAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Omega_CN7 *>(dev))->read_Led_Status(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Omega_CN7 *>(dev))->is_Led_Status_allowed(ty);}
};





//=========================================
//	Define classes for commands
//=========================================




/**
 *	The TemplateDevServClass singleton definition
 */

class
#ifdef _TG_WINDOWS_
	__declspec(dllexport)
#endif
	Omega_CN7Class : public Tango::DeviceClass
{
	/*----- PROTECTED REGION ID(Omega_CN7::Additionnal DServer data members) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Additionnal DServer data members



public:
//	write class properties data members
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static Omega_CN7Class *init(const char *);
	static Omega_CN7Class *instance();
	~Omega_CN7Class();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	Omega_CN7Class(string &);
	static Omega_CN7Class *_instance;
	void command_factory();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	void get_class_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
	void create_static_attribute_list(vector<Tango::Attr *> &);
	void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
	vector<string>	defaultAttList;


};

}	//	namespace

#endif	//	OMEGA_CN7CLASS_H

